%define anolis_release 11
%define somajor 2

Name: 		flex
Summary: 	A tool for generating scanners (text pattern recognizers)
Version: 	2.6.4
Release: 	%{anolis_release}%{?dist}
License: 	BSD and LGPLv2+
URL: 		https://github.com/westes/flex
Source0: 	https://github.com/westes/flex/releases/download/v%{version}/flex-%{version}.tar.gz

# https://github.com/westes/flex/pull/262
Patch1: 	0001-build-AC_USE_SYSTEM_EXTENSIONS-in-configure.ac.patch

Requires: 	m4
BuildRequires:  gettext gettext-devel bison m4 help2man
BuildRequires:  make gcc gcc-c++ automake libtool

%description
The flex program generates scanners.  Scanners are programs which can
recognize lexical patterns in text.  Flex takes pairs of regular
expressions and C code as input and generates a C source file as
output.  The output file is compiled and linked with a library to
produce an executable.  The executable searches through its input for
occurrences of the regular expressions.  When a match is found, it
executes the corresponding C code.  Flex was designed to work with
both Yacc and Bison, and is used by many programs as part of their
build process.

You should install flex if you are going to use your system for
application development.

%package -n libfl%{somajor}
Summary: Libraries for the flex scanner generator

%description -n libfl%{somajor}
flex is a tool for generating scanners.

This package contains the shared library with default implementations of
`main' and `yywrap' functions that binaries using flex can choose to link
against instead of implementing on their own.

%package -n libfl-devel
Summary: Development files for the flex scanner generator
Requires: libfl%{somajor} = %{version}-%{release}

%description -n libfl-devel
flex is a tool for generating scanners.

This package contains files required to build programs that use flex
libraries.

%package -n libfl-static
Summary: Static libraries for the flex scanner generator
Obsoletes: flex-static < %{version}-%{release}
Provides: flex-static = %{version}-%{release}
Obsoletes: flex-devel < %{version}-%{release}
Provides: flex-devel = %{version}-%{release}

%description -n libfl-static

flex is a tool for generating scanners.

This package contains the static library with default implementations of
`main' and `yywrap' functions that binaries using flex can choose to
statically link against instead of implementing their own.

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{version}-%{release}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -n %{name}-%{version} -p1

%build
autoreconf -i
%configure --docdir=%{_pkgdocdir} CFLAGS="-fPIC $RPM_OPT_FLAGS"
%make_build

%install
%make_install
rm -f $RPM_BUILD_ROOT/%{_pkgdocdir}/{README.cvs,TODO,AUTHORS,COPYING,ONEWS}

( cd ${RPM_BUILD_ROOT}
  ln -sf flex .%{_bindir}/lex
  ln -sf flex .%{_bindir}/flex++
  ln -s flex.1 .%{_mandir}/man1/lex.1
  ln -s flex.1 .%{_mandir}/man1/flex++.1
  ln -s libfl.a .%{_libdir}/libl.a
)

%find_lang flex

%generate_compatibility_deps

%check
echo ============TESTING===============
make check
echo ============END TESTING===========

%files -f flex.lang
%dir %{_pkgdocdir}
%license COPYING
%{_bindir}/*
%{_mandir}/man1/*
%{_includedir}/FlexLexer.h
%{_infodir}/flex.info*
%{abidir}/flex-option.list

%files -n libfl%{somajor}
%{_libdir}/libfl.so.%{somajor}*
%dir %{abidir}
%{abidir}/*.dump

%files -n libfl-devel
%{_includedir}/FlexLexer.h
%{_libdir}/libfl.so

%files -n libfl-static
%dir %{_pkgdocdir}
%license COPYING
%{_libdir}/*.a

%files doc
%{_pkgdocdir}/NEWS
%{_pkgdocdir}/README.md

%changelog
* Tue Apr 18 2023 Chunmei Xu <xuchunmei@linux.alibaba.com> - 2.6.4-11
- optimise spec and patch file

* Sun Jan 15 2023 Funda Wang <fundawang@yeah.net> - 2.6.4-10
- Bump release for upgrading from anolis 8

* Mon Oct 10 2022 happy_orange <songnannan@linux.alibaba.com> - 2.6.4-1
- Init package from upstream
